package soot.javaToJimple.ppa;

import polyglot.ast.Assign;
import polyglot.ast.Expr;
import polyglot.ast.Assign.Operator;
import polyglot.types.SemanticException;
import polyglot.types.Type;

public class PPAAssignHelper {
	// TODO Play with operators...
	public static void inferTypeInfo(Expr left, Expr right, Operator op, SemanticException se,
			Type newType, TypeFact origin) throws SemanticException {
		boolean leftUnsafe = !TypeFactUtil.isSafe(left);
		boolean leftAnon = TypeFactUtil.isAnonymousMagicClass(left.type());
		boolean rightUnsafe = !TypeFactUtil.isSafe(right);
		boolean rightAnon = TypeFactUtil.isAnonymousMagicClass(right.type());
		Type leftT = left.type();
		Type rightT = right.type();

		if (!leftUnsafe && !rightUnsafe) {
			return;
		}

		if (op == Assign.ASSIGN) {
			// First, check to see if we need to throw an exception.
			if (!leftAnon && !rightAnon && se != null
					&& ((leftUnsafe && rightUnsafe) || (!leftUnsafe && !rightUnsafe))) {
				throw se;
			}
			// XXX Should not transfer right into left if right is also unsafe...
			// Second check if we can change something (two types are not equal)
			else if (!leftT.equalsImpl(rightT)) {
				if (leftUnsafe
						&& !rightAnon
						&& (newType == null || (rightT.equalsImpl(newType) && !leftT
								.equalsImpl(newType)))) {
					PPAEngine.v().reportNewFact(
							new TypeFact(TypeFactUtil.getMainIndex(left), leftT, rightT,
									TypeFact.SUPER_OR_EQUALS, TypeFact.ASSIGN_STRATEGY,origin));
				} else if (rightUnsafe
						&& !leftAnon
						&& (newType == null || (leftT.equalsImpl(newType) && !rightT
								.equalsImpl(newType)))) {
					PPAEngine.v().reportNewFact(
							new TypeFact(TypeFactUtil.getMainIndex(right), rightT, leftT,
									TypeFact.CHILD_OR_EQUALS, TypeFact.ASSIGN_STRATEGY,origin));
				}
			}
		}
	}
}
