package soot.javaToJimple.ppa;

import java.util.ArrayList;
import java.util.List;

import polyglot.types.Type;

public class TypeFact {

	public static int CHILD_OR_EQUALS = 0;

	public static int UNKNOWN = 1;

	public static int SUPER_OR_EQUALS = 2;

	public static String ASSIGN_STRATEGY = "ASSIGN_STRATEGY";

	public static String BINARY_STRATEGY = "BINARY_STRATEGY";

	public static String ARRAY_STRATEGY = "ARRAY_STRATEGY";

	public static String CONDITION_STRATEGY = "CONDITION_STRATEGY";

	public static String CONDITIONAL_STRATEGY = "CONDITIONAL_STRATEGY";

	public static String METHOD_STRATEGY = "METHOD_STRATEGY";

	public static String RETURN_STRATEGY = "RETURN_STRATEGY";

	public static String SWITCH_STRATEGY = "SWITCH_STRATEGY";

	public static String UNARY_STRATEGY = "UNARY_STRATEGY";

	private PPAIndex index;

	private Type oldType;

	private Type newType;

	private int kind;

	// Usually, there will be only one in the chain, but we open the door for something more...
	private List<TypeFact> inferenceChain;

	private String strategy;

	public TypeFact(PPAIndex index, Type oldType, Type newType, int kind, String strategy,
			TypeFact typeFact) {
		super();
		this.index = index;
		this.oldType = oldType;
		this.newType = newType;
		this.kind = kind;
		this.inferenceChain = new ArrayList<TypeFact>();
		this.strategy = strategy;
		if (typeFact != null) {
			inferenceChain.add(typeFact);
		}
	}

	public PPAIndex getIndex() {
		return index;
	}

	public int getKind() {
		return kind;
	}

	public Type getNewType() {
		return newType;
	}

	public Type getOldType() {
		return oldType;
	}

	public void setIndex(PPAIndex index) {
		this.index = index;
	}

	public void setKind(int kind) {
		this.kind = kind;
	}

	public void setNewType(Type newType) {
		this.newType = newType;
	}

	public void setOldType(Type oldType) {
		this.oldType = oldType;
	}

	public List<TypeFact> getInferenceChain() {
		return inferenceChain;
	}

	public String getStrategy() {
		return strategy;
	}

	@Override
	public String toString() {
		return "Change " + oldType + " for " + newType + " at " + index;
	}

}
