package soot.javaToJimple.ppa.jj.ast;

import polyglot.ast.Node;
import polyglot.ast.QualifierNode;
import polyglot.ast.TypeNode;
import polyglot.ext.jl.ast.AmbTypeNode_c;
import polyglot.types.ClassType;
import polyglot.types.Named;
import polyglot.types.SemanticException;
import polyglot.util.Position;
import polyglot.visit.AmbiguityRemover;
import soot.javaToJimple.ppa.jj.types.MagicClass;

public class PPAAmbTypeNode_c extends AmbTypeNode_c {

	public PPAAmbTypeNode_c(Position pos, QualifierNode qual, String name) {
		super(pos, qual, name);
		// TODO Auto-generated constructor stub
	}
	
	public Node disambiguate(AmbiguityRemover sc) throws SemanticException {
		Node n = sc.nodeFactory().disamb().disambiguate(this, sc, position(), qual, name);

		if (n instanceof TypeNode) {
			return n;
		} else if (n == null) {
			// XXX We will create your node sir!
			Named named = sc.typeSystem().forName(MagicClass.MAGIC_PACKAGE + "." + name);
			if (named != null) {
				ClassType ct = (ClassType) named;
				n = sc.nodeFactory().CanonicalTypeNode(position(), ct);
				return n;
			}
		}

		throw new SemanticException("Could not find type \""
				+ (qual == null ? name : qual.toString() + "." + name) + "\".", position());
	}

}
