package soot.javaToJimple.ppa.jj.ast;

import java.util.List;

import polyglot.ast.Block;
import polyglot.ast.Node;
import polyglot.ext.jl.ast.ConstructorDecl_c;
import polyglot.types.Flags;
import polyglot.types.SemanticException;
import polyglot.util.Position;
import polyglot.visit.ExceptionChecker;

public class PPAConstructorDecl_c extends ConstructorDecl_c {
	public PPAConstructorDecl_c(Position pos, Flags flags, String name, List formals,
			List throwTypes, Block body) {
		super(pos, flags, name, formals, throwTypes, body);
	}
	
	@Override
	public Node exceptionCheck(ExceptionChecker ec) throws SemanticException {
		Node node = null;
		
		try {
			node = super.exceptionCheck(ec);
		} catch(SemanticException se) {
			// Exception for CloneNotSupported!
			if (se.getMessage().contains("java.lang.CloneNotSupportedException")) {
				ec.throwsSet().clear();
				// retry
				node = super.exceptionCheck(ec);
			} else {
//				throw se;
				// For now, ignore this error...
				ec.throwsSet().clear();
				// retry
				node = super.exceptionCheck(ec);
			}
		}
		return node;
	}
}
